/**
* Command line front end for IJVMAssembler.
*
* @author 
*   Dan Stone (<a href="mailto:dans@ontko.com"><i>dans@ontko.com</i></a>),
*   Ray Ontko & Co,
*   Richmond, Indiana, US
*/

/*

To Do:
	
Modification History:

Name             Date       Comment
---------------- ---------- ----------------------------------------
Arno Paanstra	 26-10-2000 75% Rewritten, new commandline and class call.

*/
package mic1.assembler;

import mic1.util.*;

import java.io.FileOutputStream;
import java.io.PrintStream;

public final class ijvmasm
{
	public ijvmasm( Output output, String inputFile, String outputFile )
	{
		IJVMAssembler ia = new IJVMAssembler( output, inputFile, outputFile);	
	}	
	
	public ijvmasm( Output output, String inputFile, String outputFile, String symbolsFile )
	{
		IJVMAssembler ia = new IJVMAssembler( output, inputFile, outputFile);
		
		try
		{
			ia.writeSymbols(new PrintStream(new FileOutputStream(symbolsFile)));
		}
		catch (Exception e)
		{			
			System.out.println("Error opening file " + symbolsFile);
		}	
	}
		
	
	public static void main(String args[])
	{
		ConsoleOutput output = new ConsoleOutput( System.out );
		
		if (args.length == 0 || args[0].equals("help"))
			output.println("usage: java ijvmasm <jas source file> [ijvm file]");
		else
		{
			String outfile = null;
			String infile = args[0];
			
			if (!infile.endsWith(".jas"))
			{
				output.println("Source file must be .jas file");
				System.exit(0);
			}
			
			if (args.length >= 2)
			{
				outfile = args[1];
				if (!outfile.endsWith(".ijvm"))
				{
					output.println("Destination file must be .ijvm file.");
					System.exit(0);
				}
			}
			else
				outfile = infile.substring(0, infile.length() - 4) + ".ijvm";
			
			if (args.length >= 3)
			{
				new ijvmasm( output, infile, outfile, args[2] );
			}
			else
				new ijvmasm( output, infile, outfile );
		}
	}
}