package mic1.gui;
/*
 * @(#)JListOutput.java	1.0 01/Oct/2000
 * 
 *  This program is free software; you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by 
 *  the Free Software Foundation; either version 2 of the License, or 
 *  (at your option) any later version. 
 *
 * @Version : 1.00 01/Oct/2000
 * @Author  : PB
 *
 * Description : 
 * 
 * Implements interface Output from the util package
 * 
***  

To Do:
	
Modification History:

Name             Date       Comment
---------------- ---------- ----------------------------------------
Pierre Bakker    01.10.2000 Created

*/
import java.util.*;
import javax.swing.*;
import mic1.util.*;

public class JListOutput extends JList implements Output
{
	Vector	data;
	Vector	lines;
	
	JListOutput( )
	{
		super( );
		lines = new Vector( );
		data = new Vector( );
	}
	
	/**
     * Adds a line number to the Vector lines
     *
     * @param: line number
     */
	public void addLineNr(int nLine)
	{
		lines.add(new Integer(nLine));
	}
	
	/**
     * gets the line number at a  given index number
     *
     * @param: index number
     */
	public int getLineNrAt(int nListIndex)
	{
		if(lines == null || nListIndex < 0)
			return -1;
		if(nListIndex > lines.size())
			return 0;		
		return ((Integer)lines.elementAt(nListIndex)).intValue();		
		
	}
	
	/**
     * Clears the output
     */
	public void clear( )
	{
		lines = new Vector();
		data = new Vector( );
		setListData( data );
	}
	
	/**
     * writes text to the output without a linefeed
     *
     * @param: text to be written
     */
	public void print( String s )
	{
		data.add( s );
		setListData( data );
	}
		
	/**
     * writes text to the output with a linefeed
     *
     * @param: text to be written
     */
	public void println( String s )
	{
		print( s );
		addLineNr(-1);
	}

	/**
     * writes text to a specified line in the output with a linefeed 
     *
     * @param: text to be written
     */
	public void println( int lineno, String s )
	{
		print(lineno +": "+ s );
		addLineNr(lineno);		
	}	
}