package mic1.gui;
/*
 * @(#)MyMenuBar.java	1.0 01/Oct/2000
 * 
 *  This program is free software; you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by 
 *  the Free Software Foundation; either version 2 of the License, or 
 *  (at your option) any later version. 
 *
 * @Version : 1.00 01/Oct/2000
 * @Author  : PB
 *
 * Description : 
 * 
 * Creates the menu bar and popup menus
 * 
***  

To Do:
	
Modification History:

Name             Date       Comment
---------------- ---------- ----------------------------------------
Pierre Bakker    01.10.2000 Created
Pierre Bakker	 13.12.2000 Popup menu removed
Pierre Bakker	 13.12.2000 MenuItem bugs solved
Arno Paanstra	 28.12.2000 Add configure menu and changed close-event (calls parents close methode).
Pierre Bakker	 13.01.2001 execute View -> Help Contents implemented.
Pierre Bakker	 14.01.2001 execute View -> Linenumber implentation changed.
W de Witte       18.01.2001 MenuItems voor Feel & Look
Pierre Bakker	 22.01.2001 Cleand up
Tim Helsloot     11.03.2003 replaced deprecated getLabel() by getText()

*/

import mic1.assembler.*;
import mic1.util.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.ButtonGroup;
import javax.swing.event.*;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JMenuBar;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JTabbedPane;
import javax.swing.JToolBar;
import javax.swing.KeyStroke;

import mic1.gui.editor.syntax.*;
import mic1.gui.editor.textarea.*;
import mic1.gui.editor.*;
import mic1.gui.*;

public class MyMenuBar extends JMenuBar implements ActionListener, Commands, Labels, MouseListener
{
	protected static final String 		ICONPATH 		= "mic1/gui/images/";		// root path for icons			
	protected static final ImageIcon 	m_BlankIcon 		= new ImageIcon(ICONPATH+"blank.gif");

	public static final int				OPEN_ITEM 		= 0;
	public static final int 			SAVE_ITEM		= 1;
	public static final int 			SAVEAS_ITEM		= 2;
	public static final int				SAVEALL_ITEM	= 3;
	public static final int				CLOSE_ITEMS		= 4;
	public static final int				PRINT_ITEMS		= 5;
	public static final int				EDIT_ITEMS		= 6;
	public static final int				ALL_ITEMS		= 7;
	public static final int				ASSEMBLE_ITEMS	= 8;	
	public static final int				ONRUN_ITEMS		= 9;
	public static final int				ONSTEP_ITEMS	= 10;	
	
	
	private JMenuItem			m_File_save, m_File_saveas, m_File_saveall,	// menu items for enableing and disableing										
								m_File_close, m_File_closeall,m_File_print,
								m_Edit_cut, m_Edit_copy, m_Edit_paste, 
								m_Edit_delete, m_Edit_selectall,
								m_View_console,
								m_Assembler_assemble, m_Assembler_run,		
								m_Assembler_step,	m_Assembler_stop, m_Assembler_reset,
								m_Assembler_runtobreakpoint, m_Assembler_addbreakpoint,
								m_Assembler_removebreakpoint,
								m_Configure_customize;
								
	private JRadioButtonMenuItem m_Configure_motifstyle,m_Configure_metalstyle,
								 m_Configure_winstyle;
								  
	private JRadioButtonMenuItem m_View_SP, m_View_LV;
	private MyButton			m_New, m_Save, m_Saveall, m_Print,
								m_Assemble, m_Stop, m_Run, m_Step,
								m_AddbreakPoint, m_RemovebreakPoint;
	private JCheckBoxMenuItem	m_View_lineNr;
	private MainFrame			m_Parent;  	
	private boolean				m_bRaised,								// close button presses or released
								m_bCloseButton;							// enable/disable close button
	

	MyMenuBar(MainFrame caller)
	{
		m_Parent = caller;		
		createMenu();	
		addMouseListener(this);
		m_bCloseButton = false;
		m_bRaised = true;
		
	}

	/**
	 * enables menu items
	 *
	 * @param : state
	 * @param : id
	 */
	public void setEnabled(boolean state, int id)
	{
		if(id == ALL_ITEMS)
		{			
			setEnabled(state, SAVE_ITEM);
			setEnabled(state, SAVEAS_ITEM);
			setEnabled(state, SAVEALL_ITEM);
			setEnabled(state, CLOSE_ITEMS);
			setEnabled(state, PRINT_ITEMS);
			setEnabled(state, EDIT_ITEMS);
			setEnabled(state, ASSEMBLE_ITEMS);			
		}
		if(id == SAVE_ITEM)
		{	m_File_save.setEnabled(state);
			m_Save.setEnabled(state);			
		}
		if(id == SAVEAS_ITEM)
			m_File_saveas.setEnabled(state);
		if(id == SAVEALL_ITEM)
		{	m_File_saveall.setEnabled(state);
			m_Saveall.setEnabled(state);
		}
		if(id == CLOSE_ITEMS)
		{
			m_File_close.setEnabled(state);
			m_File_closeall.setEnabled(state);
			setDocumentCloseButton(state);
		}
		if(id == PRINT_ITEMS)
		{	m_Print.setEnabled(state);
			m_File_print.setEnabled(state);
		}
		if(id == EDIT_ITEMS)
		{	m_Edit_cut.setEnabled(state);
			m_Edit_copy.setEnabled(state);
			m_Edit_paste.setEnabled(state);
			m_Edit_delete.setEnabled(state);
			m_Edit_selectall.setEnabled(state);
		}
		if(id == ASSEMBLE_ITEMS)
		{			
			m_Assemble.setEnabled(state);
			m_Stop.setEnabled(state);
			m_Run.setEnabled(state);
			m_Step.setEnabled(state);
			m_AddbreakPoint.setEnabled(state);
			m_RemovebreakPoint.setEnabled(state);
			m_Assembler_assemble.setEnabled(state);
			m_Assembler_run.setEnabled(state);
			m_Assembler_step.setEnabled(state);
			m_Assembler_stop.setEnabled(state);
			m_Assembler_reset.setEnabled(state);
			m_Assembler_runtobreakpoint.setEnabled(state);
			m_Assembler_addbreakpoint.setEnabled(state);
			m_Assembler_removebreakpoint.setEnabled(state);
		}	
		if(id == ONRUN_ITEMS)
		{
			setEnabled(state, ALL_ITEMS);	
		
			m_Stop.setEnabled(!state);
			m_Assembler_stop.setEnabled(!state);
		}
		if(id == ONSTEP_ITEMS)
		{
			setEnabled(state, ALL_ITEMS);	
			setEnabled(!state, ASSEMBLE_ITEMS);			
		}
	}
	
	/**
	 * creates the tool bar
	 */
    protected JToolBar createToolBar()
    {      	
    	JToolBar toolBar = new JToolBar();
    	
    	m_New = new MyButton(NEW.sLabel, new ImageIcon(ICONPATH+"new.gif"));        
        m_New.setToolTipText("New document");        
        m_New.addActionListener(this);

    	MyButton btOpen = new MyButton(OPEN.sLabel, new ImageIcon(ICONPATH+"open.gif"));
        btOpen.setToolTipText("Open document");        
        btOpen.addActionListener(this);
        
    	m_Save = new MyButton(SAVE.sLabel, new ImageIcon(ICONPATH+"save.gif"));
        m_Save.setToolTipText("Save document");
        m_Save.setEnabled(false);
        m_Save.addActionListener(this);

    	m_Saveall = new MyButton(SAVEALL.sLabel, new ImageIcon(ICONPATH+"saveall.gif"));
        m_Saveall.setToolTipText("Save all documents");
        m_Saveall.setEnabled(false);
        m_Saveall.addActionListener(this); 
        
    	m_Print = new MyButton(PRINT.sLabel, new ImageIcon(ICONPATH+"print.gif"));
        m_Print.setToolTipText("Print document");
        m_Print.setEnabled(false);
        m_Print.addActionListener(this);
        	        
    	m_Assemble = new MyButton(ASSEMBLE.sLabel, new ImageIcon(ICONPATH+"assemble.gif"));
        m_Assemble.setToolTipText("Assemble");
        m_Assemble.addActionListener(this);
        
    	m_Run = new MyButton(RUN.sLabel, new ImageIcon(ICONPATH+"run.gif"));
        m_Run.setToolTipText("Run");
        m_Run.addActionListener(this);

    	m_Step = new MyButton(STEP.sLabel, new ImageIcon(ICONPATH+"step.gif"));
        m_Step.setToolTipText("Step into");
        m_Step.addActionListener(this);

    	m_Stop = new MyButton(STOP.sLabel, new ImageIcon(ICONPATH+"stop.gif"));
        m_Stop.setToolTipText("Stop");
        m_Stop.addActionListener(this);
        
    	m_AddbreakPoint = new MyButton(ADDBREAKPOINT.sLabel, new ImageIcon(ICONPATH+"addbreakpoint.gif"));
        m_AddbreakPoint.setToolTipText("Add breakpoint");
        m_AddbreakPoint.addActionListener(this);

    	m_RemovebreakPoint = new MyButton(REMOVEBREAKPOINT.sLabel, new ImageIcon(ICONPATH+"removebreakpoint.gif"));
        m_RemovebreakPoint.setToolTipText("Remove breakpoint");
        m_RemovebreakPoint.addActionListener(this);

        toolBar.add(m_New);
        toolBar.addSeparator();
        toolBar.add(btOpen);
        toolBar.add(m_Save);        
        toolBar.add(m_Saveall);
        toolBar.add(m_Print);
        toolBar.addSeparator();
        toolBar.add(m_Assemble);
        toolBar.add(m_Run);
        toolBar.add(m_Step);
        toolBar.add(m_Stop);
        toolBar.add(m_AddbreakPoint);
        toolBar.add(m_RemovebreakPoint);
        
    	return toolBar;
    }

	/**
	 * enables the close button in het right corner of the menu bar
	 *
	 * @param : state
	 */
	public void setDocumentCloseButton(boolean bState)
	{
		m_bCloseButton = bState; 
		repaint();
	}

	/**
	 * creates the menu bar and all it's items
	 */
	private void createMenu()
	{
		Font menuFont = m_Parent.getPropertiesManager().getMenuFont();
		Font menuItemFont = m_Parent.getPropertiesManager().getMenuItemFont();
    	//File Menu
    	JMenu fileMenu = new JMenu("File");
    	fileMenu.setMnemonic(KeyEvent.VK_F);
    	fileMenu.setFont(menuFont);
    	  // new
    	  ImageIcon fileIcon_new = new ImageIcon(ICONPATH+"new.gif");
    	  JMenuItem file_new = new JMenuItem(NEW.sLabel, fileIcon_new);    	      	  
    	  file_new.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
    	  file_new.setMnemonic(KeyEvent.VK_N);    	      	  
    	  file_new.setFont(menuItemFont);
    	  file_new.addActionListener(this);
    	  // open
    	  ImageIcon fileIcon_open = new ImageIcon(ICONPATH+"open.gif");
    	  JMenuItem file_open = new JMenuItem(OPEN.sLabel,fileIcon_open);    	  
    	  file_open.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));
    	  file_open.setMnemonic(KeyEvent.VK_O);    	  
    	  file_open.setFont(menuItemFont);
    	  file_open.addActionListener(this);
    	  // close    	  
    	  m_File_close = new JMenuItem(CLOSE.sLabel, m_BlankIcon);    	  
    	  m_File_close.setMnemonic(KeyEvent.VK_C);
    	  m_File_close.setFont(menuItemFont);
    	  m_File_close.addActionListener(this);    	  
		  // close all
    	  m_File_closeall = new JMenuItem(CLOSEALL.sLabel, m_BlankIcon);    	  
    	  m_File_closeall.setMnemonic(KeyEvent.VK_E);
    	  m_File_closeall.setFont(menuItemFont);
    	  m_File_closeall.addActionListener(this);    	  
    	  // save
    	  ImageIcon fileIcon_save = new ImageIcon(ICONPATH+"save.gif");
    	  m_File_save = new JMenuItem(SAVE.sLabel, fileIcon_save);    	  
    	  m_File_save.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK));
    	  m_File_save.setMnemonic(KeyEvent.VK_S);
    	  m_File_save.setFont(menuItemFont);    	  
    	  m_File_save.addActionListener(this);
    	  // saveas
    	  m_File_saveas = new JMenuItem(SAVEAS.sLabel, m_BlankIcon);    	  
    	  m_File_saveas.setMnemonic(KeyEvent.VK_A);
    	  m_File_saveas.setFont(menuItemFont);    	  
    	  m_File_saveas.addActionListener(this);
		  // save all	
		  ImageIcon fileIcon_saveall = new ImageIcon(ICONPATH+"saveall.gif");
    	  m_File_saveall = new JMenuItem(SAVEALL.sLabel, fileIcon_saveall);    	  
    	  m_File_saveall.setMnemonic(KeyEvent.VK_L);
    	  m_File_saveall.setFont(menuItemFont);    	  
    	  m_File_saveall.addActionListener(this);
    	  // print
		  ImageIcon fileIcon_print = new ImageIcon(ICONPATH+"print.gif");
    	  m_File_print = new JMenuItem(PRINT.sLabel, fileIcon_print);    	  
    	  m_File_print.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P, ActionEvent.CTRL_MASK));
    	  m_File_print.setMnemonic(KeyEvent.VK_P);   
    	  m_File_print.setFont(menuItemFont); 	  
    	  m_File_print.addActionListener(this);
		  // exit
    	  JMenuItem file_exit = new JMenuItem(EXIT.sLabel, m_BlankIcon);
    	  file_exit.setMnemonic(KeyEvent.VK_X); 
    	  file_exit.setFont(menuItemFont);   	  
    	  file_exit.addActionListener(this);
    	  
		  fileMenu.add(file_new);
		  fileMenu.add(file_open);
		  fileMenu.add(m_File_close);
		  fileMenu.add(m_File_closeall);
		  fileMenu.add(m_File_save);
		  fileMenu.add(m_File_saveas);		 
		  fileMenu.add(m_File_saveall);
		  fileMenu.addSeparator();
		  fileMenu.add(m_File_print);
		  fileMenu.addSeparator();
		  fileMenu.add(file_exit);		
	  
    	//Edit Menu
    	JMenu editMenu = new JMenu("Edit");
    	  editMenu.setMnemonic(KeyEvent.VK_E);
    	  editMenu.setFont(menuFont);
    	  // cut
    	  ImageIcon editIcon_cut = new ImageIcon(ICONPATH+"cut.gif");
    	  m_Edit_cut = new JMenuItem(CUT.sLabel, editIcon_cut);
    	  m_Edit_cut.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, ActionEvent.CTRL_MASK));
    	  m_Edit_cut.setMnemonic(KeyEvent.VK_T);
    	  m_Edit_cut.setFont(menuItemFont);
    	  m_Edit_cut.addActionListener(this);
    	  // copy
    	  ImageIcon editIcon_copy = new ImageIcon(ICONPATH+"copy.gif");
    	  m_Edit_copy = new JMenuItem(COPY.sLabel, editIcon_copy);
    	  m_Edit_copy.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, ActionEvent.CTRL_MASK));
    	  m_Edit_copy.setMnemonic(KeyEvent.VK_C);
    	  m_Edit_copy.setFont(menuItemFont);
    	  m_Edit_copy.addActionListener(this);
    	  // paste
    	  ImageIcon editIcon_paste = new ImageIcon(ICONPATH+"paste.gif");
    	  m_Edit_paste = new JMenuItem(PASTE.sLabel, editIcon_paste);
    	  m_Edit_paste.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, ActionEvent.CTRL_MASK));
    	  m_Edit_paste.setMnemonic(KeyEvent.VK_P);
    	  m_Edit_paste.setFont(menuItemFont);
    	  m_Edit_paste.addActionListener(this);
		  // delete
    	  ImageIcon editIcon_delete = new ImageIcon(ICONPATH+"delete.gif");
    	  m_Edit_delete = new JMenuItem(DELETE.sLabel, editIcon_delete);
    	  m_Edit_delete.setMnemonic(KeyEvent.VK_D);
    	  m_Edit_delete.setFont(menuItemFont);
    	  m_Edit_delete.addActionListener(this);
		  // select all
    	  m_Edit_selectall = new JMenuItem(SELECTALL.sLabel, m_BlankIcon);
    	  m_Edit_selectall.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A, ActionEvent.CTRL_MASK));
    	  m_Edit_selectall.setMnemonic(KeyEvent.VK_A);
    	  m_Edit_selectall.setFont(menuItemFont);
    	  m_Edit_selectall.addActionListener(this);

		  editMenu.add(m_Edit_cut);
		  editMenu.add(m_Edit_copy);
		  editMenu.add(m_Edit_paste);
		  editMenu.add(m_Edit_delete);
		  editMenu.addSeparator();
		  editMenu.add(m_Edit_selectall);

    	//View Menu
    	JMenu viewMenu = new JMenu("View");
    	  viewMenu.setMnemonic(KeyEvent.VK_V);
    	  viewMenu.setFont(menuFont);

    	  // console
		  m_View_console = new JMenuItem(CONSOLE.sLabel, m_BlankIcon);
    	  m_View_console.setAccelerator(KeyStroke.getKeyStroke("F3"));
		  m_View_console.setMnemonic(KeyEvent.VK_C);
    	  m_View_console.setFont(menuItemFont);
    	  m_View_console.addActionListener(this);
		  
    	  // line numbers
    	  m_View_lineNr = new JCheckBoxMenuItem(LINENR.sLabel, m_BlankIcon);
		  m_View_lineNr.setMnemonic(KeyEvent.VK_L);
		  m_View_lineNr.setFont(menuItemFont);
		  m_View_lineNr.setState(m_Parent.getPropertiesManager().isLineNrEnabled());
		  m_View_lineNr.addActionListener(this);
		  
		  viewMenu.add(m_View_console);
		  viewMenu.addSeparator();
		  viewMenu.add(m_View_lineNr);

    	//Assembler Menu
    	JMenu assemblerMenu = new JMenu("Assembler");
    	  assemblerMenu.setMnemonic(KeyEvent.VK_A);
    	  assemblerMenu.setFont(menuFont);
		  // assemble
		  ImageIcon assemblerIcon_assemble = new ImageIcon(ICONPATH+"assemble.gif");
    	  m_Assembler_assemble = new JMenuItem(ASSEMBLE.sLabel, assemblerIcon_assemble);    	  
    	  m_Assembler_assemble.setAccelerator(KeyStroke.getKeyStroke("F5"));
    	  m_Assembler_assemble.setMnemonic(KeyEvent.VK_A);
    	  m_Assembler_assemble.setFont(menuItemFont);    	  
    	  m_Assembler_assemble.addActionListener(this);
		  // run
		  ImageIcon assemblerIcon_run = new ImageIcon(ICONPATH+"run.gif");		  
    	  m_Assembler_run = new JMenuItem(RUN.sLabel, assemblerIcon_run);    	  
    	  m_Assembler_run.setAccelerator(KeyStroke.getKeyStroke("F6"));
    	  m_Assembler_run.setMnemonic(KeyEvent.VK_R);
    	  m_Assembler_run.setFont(menuItemFont);    	  
    	  m_Assembler_run.addActionListener(this);
		  // step
		  ImageIcon assemblerIcon_step = new ImageIcon(ICONPATH+"step.gif");
    	  m_Assembler_step = new JMenuItem(STEP.sLabel, assemblerIcon_step);    	  
    	  m_Assembler_step.setAccelerator(KeyStroke.getKeyStroke("F7"));    	  
    	  m_Assembler_step.setMnemonic(KeyEvent.VK_S);
    	  m_Assembler_step.setFont(menuItemFont);    	  
    	  m_Assembler_step.addActionListener(this);
  		  // stop
		  ImageIcon assemblerIcon_stop = new ImageIcon(ICONPATH+"stop.gif");
    	  m_Assembler_stop = new JMenuItem(STOP.sLabel, assemblerIcon_stop);    	  
		  m_Assembler_stop.setAccelerator(KeyStroke.getKeyStroke("F8"));
    	  m_Assembler_stop.setMnemonic(KeyEvent.VK_P);
    	  m_Assembler_stop.setFont(menuItemFont);    	  
    	  m_Assembler_stop.addActionListener(this);
		  // reset
		  m_Assembler_reset = new JMenuItem(RESETSIM.sLabel, m_BlankIcon);    	  
		  m_Assembler_reset.setAccelerator(KeyStroke.getKeyStroke("F4"));
    	  m_Assembler_reset.setMnemonic(KeyEvent.VK_S);
    	  m_Assembler_reset.setFont(menuItemFont);    	  
    	  m_Assembler_reset.addActionListener(this);
		  // run to breakpoint
		  ImageIcon assemblerIcon_runtobreakpoint = new ImageIcon(ICONPATH+"runbreakpoint.gif");
    	  m_Assembler_runtobreakpoint = new JMenuItem(RUNTOBP.sLabel, assemblerIcon_runtobreakpoint);    	  
		  m_Assembler_runtobreakpoint.setAccelerator(KeyStroke.getKeyStroke("F9"));
    	  m_Assembler_runtobreakpoint.setMnemonic(KeyEvent.VK_B);
    	  m_Assembler_runtobreakpoint.setFont(menuItemFont);    	  
    	  m_Assembler_runtobreakpoint.addActionListener(this);
		  // add breakpoint
		  ImageIcon assemblerIcon_addbreakpoint = new ImageIcon(ICONPATH+"addbreakpoint.gif");
    	  m_Assembler_addbreakpoint = new JMenuItem(ADDBREAKPOINT.sLabel, assemblerIcon_addbreakpoint);    	  
		  m_Assembler_addbreakpoint.setAccelerator(KeyStroke.getKeyStroke("F11"));
    	  m_Assembler_addbreakpoint.setMnemonic(KeyEvent.VK_PLUS);
    	  m_Assembler_addbreakpoint.setFont(menuItemFont);    	  
    	  m_Assembler_addbreakpoint.addActionListener(this);    	  
		  // remove breakpoint
		  ImageIcon assemblerIcon_removebreakpoint = new ImageIcon(ICONPATH+"removebreakpoint.gif");
    	  m_Assembler_removebreakpoint = new JMenuItem(REMOVEBREAKPOINT.sLabel, assemblerIcon_removebreakpoint);    	  
		  m_Assembler_removebreakpoint.setAccelerator(KeyStroke.getKeyStroke("F12"));
    	  m_Assembler_removebreakpoint.setMnemonic(KeyEvent.VK_MINUS);
    	  m_Assembler_removebreakpoint.setFont(menuItemFont);    	  
    	  m_Assembler_removebreakpoint.addActionListener(this);

    	  assemblerMenu.add(m_Assembler_assemble);
    	  assemblerMenu.addSeparator();    	  
    	  assemblerMenu.add(m_Assembler_run);
    	  assemblerMenu.add(m_Assembler_step);
    	  assemblerMenu.add(m_Assembler_stop);
    	  assemblerMenu.add(m_Assembler_reset);
    	  assemblerMenu.addSeparator();
    	  assemblerMenu.add(m_Assembler_runtobreakpoint);    	  
    	  assemblerMenu.add(m_Assembler_addbreakpoint);
    	  assemblerMenu.add(m_Assembler_removebreakpoint);

		//Configure Menu
    	JMenu configureMenu = new JMenu("Configure");
    	  configureMenu.setMnemonic(KeyEvent.VK_C);
    	  configureMenu.setFont(menuFont);
		  // customize
		  m_Configure_customize = new JMenuItem(CUSTOMIZE.sLabel, m_BlankIcon);    	  
		  m_Configure_customize.setMnemonic(KeyEvent.VK_C);
    	  m_Configure_customize.setFont(menuItemFont);    	  
    	  m_Configure_customize.addActionListener(this);

		  m_Configure_metalstyle = new JRadioButtonMenuItem(JAVASTYLE.sLabel, m_BlankIcon);    	  
		  m_Configure_metalstyle.setMnemonic(KeyEvent.VK_J);
    	  m_Configure_metalstyle.setFont(menuItemFont);    	  
    	  m_Configure_metalstyle.addActionListener(this);

		  m_Configure_motifstyle = new JRadioButtonMenuItem(MOTIFSTYLE.sLabel, m_BlankIcon);    	  
		  m_Configure_motifstyle.setMnemonic(KeyEvent.VK_M);
    	  m_Configure_motifstyle.setFont(menuItemFont);    	  
    	  m_Configure_motifstyle.addActionListener(this);

		  m_Configure_winstyle = new JRadioButtonMenuItem(WINSTYLE.sLabel, m_BlankIcon);    	  
		  m_Configure_winstyle.setMnemonic(KeyEvent.VK_W);
    	  m_Configure_winstyle.setFont(menuItemFont);    	  
    	  m_Configure_winstyle.addActionListener(this);
    	  
    	  configureMenu.add(m_Configure_customize);	
    	  configureMenu.addSeparator();
    	  configureMenu.add(m_Configure_metalstyle);
    	  configureMenu.add(m_Configure_motifstyle);
    	  configureMenu.add(m_Configure_winstyle);
  	  
    	// Help menu  
    	JMenu helpMenu = new JMenu("Help");
    	  helpMenu.setMnemonic(KeyEvent.VK_H);
    	  helpMenu.setFont(menuFont);
		  // help contents
		  ImageIcon helpIcon_contents = new ImageIcon(ICONPATH+"help.gif");
    	  JMenuItem help_contents = new JMenuItem(CONTENTS.sLabel, helpIcon_contents);
    	  help_contents.setAccelerator(KeyStroke.getKeyStroke("F1"));
    	  help_contents.setMnemonic(KeyEvent.VK_H);
    	  help_contents.setFont(menuItemFont);
    	  help_contents.addActionListener(this);
    	  // about
		  ImageIcon helpIcon_about = new ImageIcon(ICONPATH+"about.gif");
    	  JMenuItem help_about = new JMenuItem(ABOUT.sLabel, helpIcon_about);    	  
    	  help_about.setMnemonic(KeyEvent.VK_A);
    	  help_about.setFont(menuItemFont);
    	  help_about.addActionListener(this);
		  
		  helpMenu.add(help_contents);
		  helpMenu.addSeparator();
    	  helpMenu.add(help_about);

        add(fileMenu);
        add(editMenu);
        add(viewMenu);
        add(assemblerMenu);
        add(configureMenu);        
        add(helpMenu);        
	}

	/**
     * commands to be executed called by an event
     *
     * @param : Label form interface Commands or Labels
     */
	public void executeCommand(String label)
	{
		// file -> new
		if (label.equals(NEW.sLabel))
		{	
			m_Parent.createInternalFrame();			
			setDocumentCloseButton(true);        
		}
		// file -> open	
		else if (label.equals(OPEN.sLabel))
		{
			m_Parent.fileChooser(OPEN_ITEM);
			setDocumentCloseButton(true);        
		}
		// file -> close
		else if (label.equals(CLOSE.sLabel))
			m_Parent.closeSelectedDocument();
		// file -> close all
		else if (label.equals(CLOSEALL.sLabel))
		{
			m_Parent.closeAllDocuments();
			setDocumentCloseButton(false);
			setEnabled(false, ALL_ITEMS);
		}
		// file -> save
		else if (label.equals(SAVE.sLabel))
			m_Parent.fileChooser(SAVE_ITEM);
		// file -> save as
		else if (label.equals(SAVEAS.sLabel))			
			m_Parent.fileChooser(SAVEAS_ITEM);
		// file -> save all
		else if (label.equals(SAVEALL.sLabel))			
			m_Parent.fileChooser(SAVEALL_ITEM);
		// file -> print
		else if (label.equals(PRINT.sLabel))
			((Editor)m_Parent.getSelectedDocument()).print();
		// file -> exit			
		else if (label.equals(EXIT.sLabel))			
			m_Parent.close();				
		// edit -> cut
		else if (label.equals(CUT.sLabel))
		{
			Editor tmp = (Editor)m_Parent.getSelectedDocument();
			if(tmp != null)
				tmp.cut();	
		}		
		// edit -> copy
		else if (label.equals(COPY.sLabel))
		{
			Editor tmp = (Editor)m_Parent.getSelectedDocument();
			if(tmp != null)
				tmp.copy();
		}			
		// edit -> paste
		else if (label.equals(PASTE.sLabel))
		{
			Editor tmp = (Editor)m_Parent.getSelectedDocument();
			if(tmp != null)
				tmp.paste();
		}						
		// edit -> delete
		else if (label.equals(DELETE.sLabel))
		{	Editor tmp = (Editor)m_Parent.getSelectedDocument();
			if(tmp != null)
				tmp.delete();
		}
		// edit -> select all
		else if (label.equals(SELECTALL.sLabel))
		{
			Editor tmp = (Editor)m_Parent.getSelectedDocument();
			if(tmp != null)
				tmp.selectAll();
		}						
		// view -> console
		else if (label.equals(CONSOLE.sLabel))
		{
			m_Parent.showConsole();
		}					
		// view -> line numbers
		else if (label.equals(LINENR.sLabel))
		{
			boolean bState = m_View_lineNr.getState();
			m_Parent.setEditorLineNrs(bState);
			m_Parent.getPropertiesManager().setLineNr(bState);
		}					
	
		// assembler -> assemble
		else if (label.equals(ASSEMBLE.sLabel))
		{
			Output output = m_Parent.getOutput();
			output.clear();					
			
			executeCommand(SAVE.sLabel);
			executeCommand(RESETSIM.sLabel);			
			Editor input = (Editor)m_Parent.getSelectedDocument();
			if(!input.isNew())
			{
				StringBuffer in = new StringBuffer(input.getPath());
				StringBuffer out = new StringBuffer(in.toString());
				out = out.replace(in.length()-3, in.length()+1, "ijvm");
				new ijvmasm(output, in.toString(), out.toString());				
			}
			else
			{
				JOptionPane.showMessageDialog(input,
											  MESS_SAVEFIRST.sLabel, TITLE_SAVEFIRST.sLabel,
											  JOptionPane.ERROR_MESSAGE);
			}			
		}	
		// assembler -> step
		else if (label.equals(STEP.sLabel))
		{
			Editor input = (Editor)m_Parent.getSelectedDocument();
			if(!input.isNew())
			{
				String sPath = new String(input.getPath());
				if(sPath.endsWith(".jas"))
				{
					sPath = sPath.substring(0, sPath.length()-3);
					sPath += "ijvm";
				}
				m_Parent.startSimulator(sPath, true);
			}
			else
			{
				JOptionPane.showMessageDialog(input,
											  MESS_SAVEFIRST.sLabel, TITLE_SAVEFIRST.sLabel,
										  	  JOptionPane.ERROR_MESSAGE);
			}						
		}

		// assembler -> run
		else if (label.equals(RUN.sLabel))
		{
			Editor input = (Editor)m_Parent.getSelectedDocument();
			if(!input.isNew())
			{
				String sPath = new String(input.getPath());
				if(sPath.endsWith(".jas"))
				{
					sPath = sPath.substring(0,sPath.length()-3);
					sPath += "ijvm";					
				}
				m_Parent.startSimulator(sPath, false);
			}
			else
			{
				JOptionPane.showMessageDialog(input,
											  MESS_SAVEFIRST.sLabel, TITLE_SAVEFIRST.sLabel,
										  	  JOptionPane.ERROR_MESSAGE);
			}						
		}
		// assembler -> stop
		else if (label.equals(STOP.sLabel))
		{
			m_Parent.stopSimulator();	
		}
		// assembler -> reset
		else if (label.equals(RESETSIM.sLabel))
		{
			m_Parent.resetSimulator();	
		}
		// assembler -> run to breakpoint
		else if (label.equals(RUNTOBP.sLabel))
		{
			Editor input = (Editor)m_Parent.getSelectedDocument();
			if(!input.isNew())
			{
				String sPath = new String(input.getPath());
				if(sPath.endsWith(".jas"))
				{
					sPath = sPath.substring(0,sPath.length()-3);
					sPath += "ijvm";
				}
				m_Parent.runToBreakpoint(sPath);
			}
			else
			{
				JOptionPane.showMessageDialog(input,
											  MESS_SAVEFIRST.sLabel, TITLE_SAVEFIRST.sLabel,
										  	  JOptionPane.ERROR_MESSAGE);
			}									
		}		
		// assemble -> add breakpoint
		else if (label.equals(ADDBREAKPOINT.sLabel))	
			((Editor)m_Parent.getSelectedDocument()).addBreakpoint();			
		// assemble -> remove breakpoint	
		else if (label.equals(REMOVEBREAKPOINT.sLabel))	
			((Editor)m_Parent.getSelectedDocument()).removeBreakpoint();
		
		// configure -> customize
		else if (label.equals(CUSTOMIZE.sLabel))	
		{
			m_Parent.showCustomizeFrame();
		}
		// configure -> Java Look & Feel
		else if (label.equals(JAVASTYLE.sLabel))	
		{
			m_Parent.setLookAndFeel(MainFrame.metal_style);
			m_Configure_metalstyle.setSelected(true);
			m_Configure_motifstyle.setSelected(false);
			m_Configure_winstyle.setSelected(false);
		}
		// configure -> Motif Look & Feel
		else if(label.equals(MOTIFSTYLE.sLabel))
		{
			m_Parent.setLookAndFeel(MainFrame.motif_style);
			m_Configure_metalstyle.setSelected(false);
			m_Configure_motifstyle.setSelected(true);
			m_Configure_winstyle.setSelected(false);
		}
		// configure -> MS-Windows Look & Feel
		else if(label.equals(WINSTYLE.sLabel))	
		{
			m_Parent.setLookAndFeel(MainFrame.win_style);
			m_Configure_metalstyle.setSelected(false);
			m_Configure_motifstyle.setSelected(false);
			m_Configure_winstyle.setSelected(true);
		}		
		// help -> help contents
		else if (label.equals(CONTENTS.sLabel))				
			m_Parent.createInternalHelpFrame();
		// help -> about
		else if (label.equals(ABOUT.sLabel))				
			m_Parent.createAboutDialog();
	}


/******************************EVENT HANDLERS**************************************/	
	/**
	 * called by action event
	 */
	public void actionPerformed(ActionEvent e)
	{		
		if(e.getSource() instanceof MyButton)
			executeCommand( ((MyButton)e.getSource()).getText() );
		// menu item action
		if(e.getSource() instanceof JMenuItem)
			executeCommand( ((JMenuItem)e.getSource()).getText());		
	}

	public void mouseEntered(MouseEvent me)			{}
	public void mouseExited(MouseEvent me) 			{}
	public void mouseClicked(MouseEvent me)			{}
	public void mouseReleased(MouseEvent me)		
	{	//close button upper right corner 
		if(me.getX()>= getWidth()-20 && me.getX()<=getWidth()-6 && me.getY()>=4 && me.getY()<=20)
		{			
			m_bRaised = true;
			repaint();
			executeCommand(CLOSE.sLabel);			
		}
		else if(m_bRaised == false)
		{	
			m_bRaised = true;
			repaint();
		}
	}
	public void mousePressed(MouseEvent me)
	{	//close button upper right corner	
		if(me.getX()>= getWidth()-20 && me.getX()<=getWidth()-6 && me.getY()>=4 && me.getY()<=20)
		{		
			m_bRaised = false;
			repaint();	
		}
	}

	public void paint(Graphics g)
	{
		super.paint(g);
		
		if(m_bCloseButton)
		{
			int width 	= getWidth();
			
			g.setColor(Color.lightGray);        
        	g.fill3DRect(width-20, 4, 14,14, m_bRaised);

	        g.setColor(Color.black);
	        // big way of drawing a close button cross
			/*	        --    --
				         --  --
				          ----
				           -- 
				          ----
				         --  --
				        --    --
			*/
	        g.drawLine(width-17,7, width-16,7);	        g.drawLine(width-11,7, width-10,7);
	        g.drawLine(width-16,8, width-15,8);			g.drawLine(width-12,8, width-11,8);
	        					g.drawLine(width-15,9, width-12,9);
	        					g.drawLine(width-14,10, width-13,10);
	        					g.drawLine(width-15,11, width-12,11);	        
	        g.drawLine(width-16,12, width-15,12);		g.drawLine(width-12,12, width-11,12);
			g.drawLine(width-17,13, width-16,13);		g.drawLine(width-11,13, width-10,13);
	     }
	}
}

class MyButton extends JButton implements Commands 
{
	private String m_sLabel;
	
/********************************CONSTRUCTORS*************************************/    	
	public MyButton(String label, Icon icon)
	{
		super(icon);
		m_sLabel = label;		
	}
	
	//************************************************************** 
	// returns the label of this object
	public String getText()
	{
		return m_sLabel;
	}
		
}
