package mic1.gui;
/*
 * @(#)ResizableTable.java	1.00 18/Jav/2001
 * 
 *  This program is free software; you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by 
 *  the Free Software Foundation; either version 2 of the License, or 
 *  (at your option) any later version. 
 *
 * @Version : 1.00 18/Jav/2001
 * @Author  : Richard Klos
 *
 * Description : A Table with only one column. It can be resized to
 *               fit into a certain pixel height.
 * 
 * 
 * 
***  

To Do:



Modification History:

Name             Date       Comment
---------------- ---------- ----------------------------------------
RIchard Klos     18.01.2001 Created.
                            
*/

import mic1.ijvm.Mic1Interface;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.table.DefaultTableModel;
import javax.swing.JTable;

class ResizableColumn extends JTable
{	
	private DefaultTableModel m_TabelModel;

	// The pixel height of a row.
	public static final int rowHeight = 16;	

	// The current number of rows in the table.
	private int m_noOfRows = 0;
	
	
	ResizableColumn()
	{
		super();
		m_TabelModel = new DefaultTableModel(0, 1);
		showVerticalLines = true;
		showHorizontalLines = true;		
		adjustModel();
	}


	/**
	 * Adjusts the number of rows according to
	 * the specified pixel height.
	 */
	public void resize(int height)
	{
		m_noOfRows = height / rowHeight;
		m_TabelModel.setRowCount(m_noOfRows);
		adjustModel();
	}
	

	private void adjustModel()
	{
		setModel(m_TabelModel);	
	}
	
	
	public int getRowCount()
	{
		return m_noOfRows;
	}
}
