package mic1.gui.editor;
/*
 * @(#)HTMLViewer.java	1.0 13/Jan/2001
 * 
 *  This program is free software; you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by 
 *  the Free Software Foundation; either version 2 of the License, or 
 *  (at your option) any later version. 
 *
 * @Version : 1.00 13/Jan/2001
 * @Author  : PB
 *
 * Description : 
 * 
 * Interpers HTML files
 * 
***  

To Do:
make the Contents in html in subdirectory /docs
	
Modification History:

Name             Date       Comment
---------------- ---------- ----------------------------------------
Pierre Bakker    13.01.2001 Created
Pierre Bakker	 14.01.2001 Constructors added and existing changed
Pierre Bakker    22.01.2001 Cleand up

*/
import java.awt.*;
import java.awt.event.*;
import java.net.*;

import javax.swing.JEditorPane;
import javax.swing.JComponent;
import javax.swing.JScrollPane;

import javax.swing.event.HyperlinkListener;
import javax.swing.event.HyperlinkEvent;
import javax.swing.text.html.HTMLDocument;
import javax.swing.text.html.HTMLFrameHyperlinkEvent;


public class HTMLViewer extends JComponent implements HyperlinkListener 
{
	private String 				m_sPrefix, m_sProtocol;
	private JEditorPane 		m_HTMLView;
	
	public HTMLViewer() throws MalformedURLException
	{
		// default file
		this("file", "index.html");
	}
	
	public HTMLViewer(String sProtocol, String sURL) throws MalformedURLException
	{
		this(sProtocol, null, sURL);		
	}
	
	public HTMLViewer(String sProtocol, String sHost, String sURL) throws MalformedURLException
	{	
		this(new URL(sProtocol, sHost, sURL));
		m_sProtocol = sProtocol+":";	
	}
	
	public HTMLViewer(String sProtocol, String sHost, String sPrefix, String sFileName) throws MalformedURLException
	{
		this(new URL(sProtocol, sHost, sPrefix+sFileName));
		m_sPrefix = sPrefix;
		m_sProtocol = sProtocol+":";
	}
	
	public HTMLViewer(URL url) 
	{
		setLayout(new BorderLayout());
		
		try
		{		
			m_HTMLView = new JEditorPane(url);
			m_HTMLView.setEditable(false);
			m_HTMLView.addHyperlinkListener(this);
			JScrollPane scroller = new JScrollPane(m_HTMLView);
			add(scroller, BorderLayout.CENTER);
		}
		catch(java.io.IOException ioe)
		{	System.out.println("error: "+ioe);	}			
	}

	/**
	 * Requestes the focus
	 */
	public void setFocus()
	{
		m_HTMLView.requestFocus();
	}


	public void hyperlinkUpdate(HyperlinkEvent e)
	{			
		if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
		{
			JEditorPane pane = (JEditorPane) e.getSource();
			try
			{				
				if(m_sPrefix != null)
					 pane.setPage(m_sProtocol+m_sPrefix+e.getDescription());
				else
					pane.setPage(e.getURL());
			}
			catch (Throwable t)
			{
				t.printStackTrace();
			}					
		}
	}
	
	
	
}
