/**
 * Modification History:
 *
 * Name             Date       Comment
 * ---------------- ---------- ----------------------------------------
 * WDW              02.11.2000 Created
 *
 *
 */

package mic1.ijvm;
import java.util.*;

public class BreakPoints extends LinkedList
{
	public BreakPoints(){}
	
	public synchronized void setBreakPoint(int nLine)
	{
		ListIterator itr = listIterator();
		int nSize = size();

		while(itr.hasNext())
		{
			Integer point = (Integer)itr.next();
			if(point.intValue() == nLine)
				return;
		}
		add(new Integer(nLine));
	}
	
	public synchronized boolean removeBreakPoint(int nLine)
	{
		Integer line = findBreakPoint(nLine);
		if(line != null)
		{
			return remove(line);
		}
		return false;
	}
	
	public synchronized boolean existBreakPoint(int nLine)
	{
		return findBreakPoint(nLine) != null;
	}
	
	protected synchronized Integer findBreakPoint(int nLine)
	{
		ListIterator itr = listIterator();
		int nSize = size();
		while(itr.hasNext())
		{
			Integer point = (Integer)itr.next();
			if(point.intValue() == nLine)
				return point;
		}	
		return null;
	}
	
	public synchronized int[] toIntArray()
	{
		ListIterator itr = listIterator();
		int nSize = size();
		int[] nArray = new int[nSize];
		int i=0;
		while(itr.hasNext())
		{
			Integer point = (Integer)itr.next();
			nArray[i++] = point.intValue();
		}
		return nArray;
	}
}
