package mic1.util;
/*
 * @(#)ConsoleOutput.java	1.01 16/Dec/2000
 * 
 *  This program is free software; you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by 
 *  the Free Software Foundation; either version 2 of the License, or 
 *  (at your option) any later version. 
 *
 * @Version : 1.20 19/Jan/2001
 * @Author  : RK
 *
 * Description : 
 * 
 * Output Console
 * 
***  

To Do:


Modification History:

Name             Date       Comment
---------------- ---------- ----------------------------------------
Richard Klos     01.11.2000 Created
Pierre Bakker	 22.01.2001 Cleaned up
                            
*/

import java.io.*;

public class ConsoleOutput implements Output
{
	PrintStream	output;
	
	public ConsoleOutput( OutputStream o )
	{
		output = new PrintStream( o );
	}

	/**
     * writes text to a specified line in the output with a linefeed 
     *
     * @param: text to be written
     */
	public void println(int lineno,  String s )
	{
		output.println(lineno +": "+ s );
	}
	
	/**
     * writes text to the output with a linefeed
     *
     * @param: text to be written
     */
	public void println( String s )
	{
		output.println( s );
	}
	
	/**
     * writes text to the output without a linefeed
     *
     * @param: text to be written
     */
	public void print( String s )
	{
		output.print( s );
	}
	
	/**
     * Clears the output
     */
	public void clear( )
	{
	}
}
