package mic1.util;
/*
 * @(#)Util.java	1.01 16/Dec/2000
 * 
 *  This program is free software; you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by 
 *  the Free Software Foundation; either version 2 of the License, or 
 *  (at your option) any later version. 
 *
 * @Version : 1.20 19/Jan/2001
 * @Author  : RK
 *
 * Description : 
 * 
 * Utility class
 * 
***  

To Do:


Modification History:

Name             Date       Comment
---------------- ---------- ----------------------------------------
Richard Klos     01.11.2000 Created
Pierre Bakker	 22.01.2001 Cleaned up
                            
*/

import java.text.NumberFormat;

public class Util
{
	/**
	 * Converts a decimal integer value to a
	 * hexadecimal string.
	 */
	public static String toHex(int decimalValue)
	{
		return Integer.toHexString(decimalValue).toUpperCase();
	}


	/**
	 * Converts a decimal integer value to a
	 * hexadecimal string with a specified number
	 * of digits.
	 */
	public static String toHex(int decimalValue, int noOfDigits)
	{
		return fillUp(Integer.toHexString(decimalValue).toUpperCase(), noOfDigits);
	}


	/**
	 * Converts a decimal integer value to a
	 * binary string.
	 */
	public static String toBinary(int decimalValue)
	{
		return Integer.toBinaryString(decimalValue);
	}


	/**
	 * Converts a decimal integer value to a
	 * binary string with a specified number
	 * of digits.
	 */
	public static String toBinary(int decimalValue, int noOfDigits)
	{
		return fillUp(Integer.toBinaryString(decimalValue), noOfDigits);
	}


	/**
 	 * Pads a string with nulls to meet the required
	 * number of digits.
	 */
	private static String fillUp(String valueString, int noOfDigits)
	{
		StringBuffer sb = new StringBuffer(noOfDigits);
		if(valueString.length() < noOfDigits)
		{
			int needed = noOfDigits - valueString.length();
			while(needed > 0)
			{
				sb.append("0");
				needed--;
			}

			return sb + valueString;
		}

		return valueString;
	}


	/**
	 * Converts a string representation of a hexadecimal
	 * value to a decimal integer.
	 */
	public static int hexToInt(String h) throws NumberFormatException
	{
		if (h.startsWith("0x"))
			return Integer.parseInt(h.substring(2), 16);
		else if (h.startsWith("#"))
			return Integer.parseInt(h.substring(1), 16);
		else if (h.startsWith("$"))
			return Integer.parseInt(h.substring(1), 16);
		else
			return Integer.parseInt(h, 16);
	}

	/**
	 * Converts a string representation of a binary
	 * value to a decimal integer.
	 */
	public static int binToInt(String h) throws NumberFormatException
	{
		return Integer.parseInt(h, 2);
	}
}
